/**
 * Appコレクション
 *
 * @author Tsue Shogo
 * @version
 *	1.0.0	2016/08/12(金) 21:48	新規作成
 */
define(function(require){
	// インクルード
	var Backbone = require('backbone');
 
	// クラス生成
	return Backbone.Collection.extend({
		/**
		 * 初期実行
		 */
		initialize: function(){
		},
		/**
		 * コレクション名
		 */
		name: '',
		/**
		 * 削除前処理
		 *
		 * @return void
		 */
		beforeRemove: function() {
		},
		/**
		 * ステータス
		 *  0: 初期状態
		 *  1: 件数取得中
		 *  2: 取得中
		 *  3: 終了処理中
		 */
		status: 0,
		/**
		 * 総件数
		 */
		total: 0,
		/**
		 * モデルを取得する
		 *
		 * @param options   オプション
		 * @return void
		 */
		gets: function(options) {
			// パラメータ
			var defaultOptions = {
				conditions: {},
				limit: 10,
				offset: 0
			}
			options = $.extend(true, {}, defaultOptions, options);
 
			// ステータス分岐
			var _this = this;
			switch(this.status) {
				case 0: // 初期状態
					this.status = 1;
					setTimeout(function() {
						_this.gets(options);
					}, 0);
					break;
				case 1: // 件数取得中
					this.status = 2;
					setTimeout(function() {
						_this.gets(options);
					}, 0);
					break;
				case 2: // 取得中
					this.status = 3;
					setTimeout(function() {
						_this.gets(options);
					}, 0);
					break;
				case 3: // 終了処理中
					this.status = 0;
					setTimeout(function() {
						_this.gets(options);
					}, 0);
					break;
				default: // キャンセル中
			}
		}
	});
});