/**
 * コンテナ
 *
 * @author Tsue Shogo
 * @version
 *	1.0.0	2016/08/09(火) 23:03	新規作成
 */
define(function(require){
	// インクルード
	var AppView = require('View/AppView');
 
	// クラス生成
	return AppView.extend({
		/**
		 * 初期実行
		 */
		initialize: function(){
		},
		/**
		 * ビュー名
		 */
		name: 'ContainerView',
		/**
		 * エレメント
		 */
		el: '#Container',
		/**
		 * イベント
		 */
		events: {
			'click a[href]': 'linkClick'
		},
		/**
		 * ビュー
		 */
		views: {},
		/**
		 * コレクション
		 */
		collections: {},
		/**
		 * 現在のlocation.href
		 */
		href: '',
		/**
		 * 新ページビュー表示，旧ページビューの非表示
		 *
		 * @return void
		 */
		updatePageView: function() {
			// 旧ページビュー削除
			this.removeChildViews('oldPageView');
			// 新ページビューの表示
			this.$el.append(this.views['pageView'].render().$el);
			// Googleアナリティクス(利用するにはGAのコードをhead内に記述)
			///var page = this.href.replace(location.protocol + '//' + location.host, '');
			///ga('send', 'pageview', page);
		},
		/**
		 * リンクのクリック
		 *
		 * @param object	eve イベント
		 * @return bool
		 */
		linkClick: function(eve) {
			// クリック対象の情報取得
			var $a = $(eve.currentTarget);
			var href = $a.attr('href');
			var thisClass = $a.prop('class');
 
			if ($a.prop('target') || href.slice(0, 4) === 'http') {
				// 内部リンク
				if ($a.prop('target') === '_self') {
					var _this = this;
					var t = setTimeout(function(){
						history.replaceState({}, "", _this.href);
					}, 100);
				}
				return;
			} else if (eve.ctrlKey || eve.metaKey) {
				// 別ウィンドウ表示
				window.open(href);
			} else if (href.slice(0, 1) !== '#') {
				// 普通のリンク
				Backbone.history.navigate(href, {trigger: true});
				$('body,html').css({scrollTop: 0});
			} else if (href === '#header') {
				// このページの先頭へ
				$('body,html').animate({scrollTop: 0}, 400, 'swing');
			} else {
				// #
			}
			// クリックイベントのキャンセル
			eve.preventDefault();
			return false;
		}
	});
});